<?php
ini_set('display_errors', 1);

require_once '../../../../resources/base_path_include.php';

require_once $base_path_to_learning_resources  . "includes/connect.php"; // use require for mandatory files
require_once $base_path_to_learning_resources . 'lib/function.php';
require_once $base_path_to_learning_resources . 'lib/validate_api_signature.php';

//valdation file
require_once $base_path_to_learning_resources . 'lib/validate_function.php';
require_once $base_path_to_learning . 'user_management/authenticate.php';
require_once $base_path_to_learning . 'functions/common_functions.php';
//db access function
require_once $base_path_to_learning_resources . 'includes/specific_db_config.php';

//aws image store
require_once $base_path_to_learning_resources . 'lib/bucket_functions/bucket_functions.php';
require_once $base_path_to_learning . "vendor/autoload.php";

require_once $base_path_to_learning_resources . 'includes/aws_bucket_config.php';
require_once $base_path_to_learning . "faculty_api/faculty_function/common_faculty_function.php";
require_once $base_path_to_learning . "principal_api/principal_function/principal_function.php";
use Aws\S3\S3Client;
use Aws\S3\Exception\S3Exception;

$postdata = json_decode(file_get_contents("php://input"), true);
// print_r($postdata);
checkIfNoPhpContentsReceive();

if (
    
    !isset($postdata['api_signature']) or !checkIfIssetAndNotEmpty($postdata['api_signature']) or
    !isset($postdata['function_type']) or !checkIfIssetAndNotEmpty($postdata['function_type'])  or
    !isset($postdata['jwt_token']) or  !checkIfIssetAndNotEmpty($postdata['jwt_token'])
) {
    errorreturn("All * fields are required.");
}
validateApiSignature($postdata['api_signature']);

$jwttoken = $postdata['jwt_token'];
$jwt_validate = authenticate_jwt($jwttoken);
$userid = $jwt_validate->data->id;
$workspace_id = $jwt_validate->data->workspace_id;
$username = $jwt_validate->data->username;
$role = $jwt_validate->data->role;
$branch_id = $jwt_validate->data->branch_id;
$institution_id = $jwt_validate->data->institution_id;

$specific_db_name = validateUserAccess($conn_rjllearning, $userid, $role, $workspace_id,["teacher"], null);
if (!$specific_db_name) {
    errorreturn('Access denied.');
} else {
    $conn_rjllearning_specific = dynamicDbConnection($specific_db_name);
}
$function_type = trim($postdata['function_type']);

// Check if the faculty exists
$Faculty_Codes = $conn_rjllearning_specific->prepare("SELECT id FROM faculty_info WHERE userid = ? AND institution_id = ? AND branch_id = ?");
$Faculty_Codes->execute(array($userid, $institution_id, $branch_id));
$result_faculty = $Faculty_Codes->fetch(PDO::FETCH_ASSOC);
if ($result_faculty === false) {
    errorreturn("Faculty Not Found.");
}

$faculty_id = $result_faculty['id'];
$teacher_data = getClassSectionSubjectsAndInChargeRoles($conn_rjllearning, $conn_rjllearning_specific, $institution_id, $userid);
$class_section_subjects  = $teacher_data['class_section_subjects'];
$class_incharge_roles = $teacher_data['class_incharge_roles'];
$staff_access_modules = $teacher_data['staff_access_modules'];
// var_dump($class_id);
checkFacultyModuleGranted($function_type, $class_section_subjects, $class_incharge_roles, $staff_access_modules, null, null, null, $conn_rjllearning);
function getvendor($conn_rjllearning_specific, $institution_id, $search_string, $branch_id,$limit, $offset)
{
    $sql = "SELECT  count(*) as total_rows FROM  unmarked_transaction_type_group where institution_id =?";
    $array_params = [$institution_id];

    $stmt = $conn_rjllearning_specific->prepare($sql);
    $stmt->execute($array_params);
    $result_total = $stmt->fetchAll();
    $totalrows = $result_total[0]['total_rows'];

    if ($limit == 'all') {

        $sql_session = "SELECT * FROM  unmarked_transaction_type_group  where institution_id =? ";
        $array_params = [$institution_id];
       

        if ($search_string != null) {
            $sql_session .= " AND name LIKE ? ";
            $array_params[] = '%' . $search_string . '%'; // Append to $array_params
        }
        
        
      $sql_session .=  "order by date_created desc, time_created desc";
        
        
    } else {
        $sql_session = "SELECT * FROM unmarked_transaction_type_group WHERE institution_id = ?";
        $array_params = [$institution_id];
        
       

        if ($search_string != null) {
            $sql_session .= " AND name LIKE ? ";
            $array_params[] = '%' . $search_string . '%'; // Append to $array_params
        }

      $sql_session .= " order by date_created desc, time_created desc ";
      $sql_session .= "LIMIT " . $offset . " ," . $limit . "";
    }
    $stmt = $conn_rjllearning_specific->prepare($sql_session);
    $stmt->execute($array_params);
    $session_rows = $stmt->fetchAll();
   
 

    $array_return = [];

    foreach ($session_rows as $row) {
     
        $vehicle_expense_id = $row['id'];
        // $branch_id = $row['branch_id'];
        
        // // Fetch branch info
        // $branch_info = getBranchInfo($conn_rjllearning_specific, $institution_id, $branch_id);
        
        // Initialize parent group name
        // $parent_group_name = null;
        
        // // Check if parent_group is set
        // if (!empty($row['parent_group'])) {
        //     $parent_group_id = $row['parent_group'];
            
        //     // Query to fetch parent group name
        //     $fetch_parent_group_sql = "SELECT name FROM unmarked_transaction_type_group WHERE id = ? and institution_id=?";
        //     $stmt = $conn_rjllearning_specific->prepare($fetch_parent_group_sql);
        //     $stmt->execute([$parent_group_id,$row['institution_id']]);
        //     $parent_group_info = $stmt->fetch(PDO::FETCH_ASSOC);
            
        //     // Assign parent group name if found
        //     if ($parent_group_info) {
        //         $parent_group_name = $parent_group_info['name'];
        //     }
        // }

        // Append vendor info to the array
        $vendor_info[] = [
            'expense_group_id' => $vehicle_expense_id,
            'institution_id' => $row['institution_id'],
            // 'branch_id' => $branch_info,
            'group_name' => $row['group_name'],
             'main_ledgerhead' => $row['main_ledgerhead'],
              'parent_lvl1' => $row['parent_lvl1'],
               'parent_lvl2' => $row['parent_lvl2'],
                'parent_lvl3' => $row['parent_lvl3'],
                 'parent_lvl4' => $row['parent_lvl4'],
                 'parent_lvl5' => $row['parent_lvl5'],
            // 'parent_group' => $parent_group_name, // Added parent group name
            // 'description' => $row['description'],
            'created_by' => $row['created_by'],
            'time_created' => $row['time_created'],
            'date_created' => $row['date_created']
        ];
    }

    if (count($session_rows) < 50) {

        return array('total_rows' => $totalrows, 'vendor_info' => $vendor_info, 'maxreach' => 1);
    } else {
        return array('total_rows' => $totalrows, 'vendor_info' => $vendor_info, 'maxreach' => 0);
    }
}


if ($postdata['function_type'] == "fetch_unmarked_expense_group") {
   
    $check_academic_confirmation = CheckAcademicSession($conn_rjllearning_specific, $institution_id);
    if ($check_academic_confirmation != true) {
        errorreturn("Access denied. Academic session not active.");
    }
    


   
    if (isset($postdata['search_string']) and !empty($postdata['search_string'])) {
        $search_string = trim($postdata['search_string']);
    } else {
        $search_string = null;
    }

    $limit = $postdata['limit'];

    $page = (isset($postdata['page']) and isNumeric($postdata['page'])) ? (int)$postdata['page'] : 1;

    if ($limit != 'all') {
        $offset = ($page - 1) * $limit;
        $success['data'] = getvendor($conn_rjllearning_specific, $institution_id, $search_string, $branch_id,$limit, $offset);
        successreturn($success);
    } else {
        $success['data'] = getvendor($conn_rjllearning_specific, $institution_id, $search_string, $branch_id,$limit, null);
        successreturn($success);
    }
}
